
#cs

TXML MT flagger.au3
Samuel Murray, 15 Feb 2019

#ce

$textfiledialog = FileOpenDialog ("Select file", @ScriptDir, "TXML files (*.txml)|All files (*.*)")
$textfileopen = FileOpen ($textfiledialog, 128)
$textfile = FileRead ($textfileopen)

$textfilewrite = FileOpen ($textfiledialog & "_flagged.txml", 129)

; $askmmm = MsgBox (4, "Flag machine translated segments?", "Flag machine translated segments with {mmm}?", 0)
; $askccc = MsgBox (4, "Flag changed segments?", "Flag changed segments with {ccc}?", 0)
; $askuuu = MsgBox (4, "Flag unchanged segments?", "Flag unchanged segments with {uuu}?", 0)

$startorend = MsgBox (4, "Add flags to end of source field?", "Add flags to end of source field?  Saying 'No' will add flags to the start of the source field.", 0)

$askmmm = InputBox ("Flag machine translated segments?", "Flag machine translated segments? If not, just press 'Cancel'.", "{mmm}")
If @error = 1 Then $askmmm = "DONTFLAGDONTFLAGDONTFLAG"
$askccc = InputBox ("Flag changed segments?", "Flag changed segments? If not, just press 'Cancel'.", "{ccc}")
If @error = 1 Then $askccc = "DONTFLAGDONTFLAGDONTFLAG"
$askuuu = InputBox ("Flag unchanged segments?", "Flag unchanged segments? If not, just press 'Cancel'.", "{uuu}")
If @error = 1 Then $askuuu = "DONTFLAGDONTFLAGDONTFLAG"

$split = StringSplit ($textfile, "<segment", 1)


FileWrite ($textfilewrite, $split[1])

For $i = 2 to $split[0]

If $startorend = 6 Then

If $askmmm = "DONTFLAGDONTFLAGDONTFLAG" Then
$x = 1
Else
If StringInStr ($split[$i], 'gtmt="true"') Then
$split[$i] = StringReplace ($split[$i], "</source", $askmmm & "</source")
EndIf
EndIf

If $askuuu = "DONTFLAGDONTFLAGDONTFLAG" Then
$x = 1
Else
If NOT StringInStr ($split[$i], 'modified="true"') Then
$split[$i] = StringReplace ($split[$i], "</source", $askuuu & "</source")
EndIf
EndIf

If $askccc = "DONTFLAGDONTFLAGDONTFLAG" Then
$x = 1
Else
If StringInStr ($split[$i], 'modified="true"') Then
$split[$i] = StringReplace ($split[$i], "</source", $askccc & "</source")
EndIf
EndIf

Else

If $askmmm = "DONTFLAGDONTFLAGDONTFLAG" Then
$x = 1
Else
If StringInStr ($split[$i], 'gtmt="true"') Then
$split[$i] = StringReplace ($split[$i], "<source>", "<source>" & $askmmm)
EndIf
EndIf

If $askuuu = "DONTFLAGDONTFLAGDONTFLAG" Then
$x = 1
Else
If NOT StringInStr ($split[$i], 'modified="true"') Then
$split[$i] = StringReplace ($split[$i], "<source>", "<source>" & $askuuu)
EndIf
EndIf

If $askccc = "DONTFLAGDONTFLAGDONTFLAG" Then
$x = 1
Else
If StringInStr ($split[$i], 'modified="true"') Then
$split[$i] = StringReplace ($split[$i], "<source>", "<source>" & $askccc)
EndIf
EndIf

EndIf

FileWrite ($textfilewrite, "<segment" & $split[$i])

Next
